#ifndef __INSTALLWATCH_H__
#define __INSTALLWATCH_H__

#define error(X) (X < 0 ? strerror(errno) : "success")

#ifdef DEBUG
#define DEBUGLINE printf("func: %s -- line: %i\n", __func__, __LINE__)
#else
#define DEBUGLINE
#endif

/* START: initialize.c */

/* We can't use _init because libc _init wasn't called yet
 * and I really want to use getenv */
extern int initialize;
void init(void);
#define CHECKINIT if (!initialize) init()

/* Some allocated strings that are paths */
extern char *instroot;
extern char *logfile;
extern char *bpath;
extern char *bjail;
/* hope we can speed things up by "caching" the len */
extern int irlen;
extern int bplen;
extern int bjlen;
/* END: initilize.c */

/* START: helper.c */
/* backup overwriten files */
void backup(const char *path);

/* is it in chroot? */
char *chpath(const char *prefix,const char *postfix);
#define chrootpath(path) (chpath(instroot,path)) 

/* build jail functionality */
void check_jail(const char *path, const char *func);

/* cononicalize the path */
char *canonicalize(const char *path);

/* syslog facility */
#define LOGLEVEL (LOG_USER | LOG_INFO | LOG_PID)
void logger(const char *format, ...) __attribute__((format(printf, 1, 2)));
/* END: helper.c */

/* START: zengarden.c */
/* orginal libc symbols */
time_t (*true_time) (time_t *);
int(*true_chmod)(const char *, mode_t);
int(*true_chown)(const char *, uid_t, gid_t);
int(*true_chroot)(const char *);
int(*true_creat)(const char *, mode_t);
int(*true_fchmod)(int, mode_t);
int(*true_fchown)(int, uid_t, gid_t);
FILE *(*true_fopen)(const char *,const char*);
int(*true_ftruncate)(int, off_t);
int(*true_lchown)(const char *, uid_t, gid_t);
int(*true_link)(const char *, const char *);
int(*true_mkdir)(const char *, mode_t);
int(*true_open)(const char *, int, ...);
int(*true_rename)(const char *, const char *);
int(*true_rmdir)(const char *);
int(*true_symlink)(const char *, const char *);
int(*true_truncate)(const char *, off_t);
int(*true_unlink)(const char *);
// 64 bit
int(*true_creat64)(const char *, __mode_t);
FILE *(*true_fopen64)(const char *,const char *);
int(*true_ftruncate64)(int, __off64_t);
int(*true_open64)(const char *, int, ...);
int(*true_truncate64)(const char *, __off64_t);
/* END: zengarden.c */

#endif /* __INSTALLWATCH_H__ */
